unit D_Cocktail;
{** 22/08/2000 Les images des melangeurs peuvent etre des bmp maintenant **}
{** Vous allez me dire : pourquoi faire un Datamodule ? Je vous repondrais
 ** que j'en avais envie.
 **}
interface

uses
  Windows, Messages, SysUtils, Classes, JPEG, gifimage, Graphics, Controls, Forms, Dialogs,
  Buttons,
  extctrls,
  u_cocktail, U_CocktailConst,
  inifiles;

type
  TDCocktail = class(TDataModule)
    VerreImageList: TImageList;
    MelangeurImageList: TImageList;
    procedure DCocktailCreate(Sender: TObject);
    procedure DCocktailDestroy(Sender: TObject);
  private
    { Dclarations prives }
    procedure LoadVerreImage;
    procedure LoadMelangeurImage;
    procedure UnLoadVerreImage;
    procedure UnLoadMelangeurImage;
  public
    procedure SetVerreImageForSpeedButton(verre : TCocktailVerre ;  sb : TSpeedButton);
    procedure SetVerreImageForBitBtn(verre : TCocktailVerre ; bb : TBitBtn);
    procedure SetVerreImageForImage(verre : TCocktailVerre ; im : TImage);
    procedure SetMelangeurImageForSpeedButton(verre : TCocktailMelangeur ;  sb : TSpeedButton);
    procedure SetMelangeurImageForBitBtn(verre : TCocktailMelangeur ; bb : TBitBtn);
    procedure SetMelangeurImageForImage(verre : TCocktailMelangeur ; im : TImage);
    { Dclarations publiques }
  end;

var
  DCocktail: TDCocktail;

implementation

uses
  u_FuncFile;
{$R *.DFM}

procedure TDCocktail.DCocktailCreate(Sender: TObject);
begin
  LoadVerreImage;
  LoadMelangeurImage;
end;

procedure TDCocktail.DCocktailDestroy(Sender: TObject);
begin
  UnLoadVerreImage;
  UnLoadMelangeurImage;
end;

procedure TDCocktail.LoadVerreImage;
var
  i : integer;
  filename : string;
  ini : TIniFile;
  icon : TIcon;
  bmp  : TBitmap;
begin
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  icon := TIcon.Create;
  for i := 0 to integer(verreAutre)  do
  begin
    filename := 'verre_'+CocktailVerre2Str(TCocktailVerre(i));
    filename := ini.ReadString(INI_SECTION_ICON, filename, '');

    if (not FileExists(FileName)) then
      FileName := PathToExe + FileName;

    if (FileExists(FileName)) then
    begin
      // Add icon
      if (GetFilenameExtension(filename) = 'ICO') then
      begin
        icon.LoadFromFile(filename);
        VerreImageList.AddIcon(icon);
      end
      else
      begin
        bmp := TBitmap.Create;
        bmp.LoadFromFile(filename);
        bmp.Width := VerreImageList.Width;
        bmp.Height := VerreImageList.Height;
        VerreImageList.Add(bmp, nil);
        bmp.Free;
      end;
    end
    else
    begin
      // Add default icon
      VerreImageList.AddIcon(Application.Icon);
    end;
  end;
  ini.Free;
  icon.Free;
end;

procedure TDCocktail.LoadMelangeurImage;
var
  i : integer;
  filename : string;
  ini : TIniFile;
  icon : TIcon;
  bmp  : TBitmap;
begin
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  icon := TIcon.Create;
  for i := 0 to integer(melAutre) do
  begin
    filename := 'mel_'+CocktailMelangeur2Str(TCocktailMelangeur(i));
     filename := ini.ReadString(INI_SECTION_ICON, filename, '');
    if (not FileExists(FileName)) then
      FileName := PathToExe + FileName;
    if (FileExists(FileName)) then
    begin
      // Add icon
      // Add icon
      if (GetFilenameExtension(filename) = 'ICO') then
      begin
        icon.LoadFromFile(filename);
        MelangeurImageList.AddIcon(icon);
      end
      else
      begin
        bmp := TBitmap.Create;
        bmp.LoadFromFile(filename);
        bmp.Width := MelangeurImageList.Width;
        bmp.Height := MelangeurImageList.Height;
        MelangeurImageList.Add(bmp, nil);
        bmp.Free;
      end;
    end
    else
    begin
      // Add default icon
      MelangeurImageList.AddIcon(Application.Icon);
    end;
  end;
  ini.Free;
  icon.Free;
end;
procedure TDCocktail.UnLoadVerreImage;
var
  i : integer;
  m : integer;
begin
  m := VerreImageList.Count - 1;
  for i := 0 to m do
  begin
    VerreImageList.Delete(0);
  end;
end;

procedure TDCocktail.UnLoadMelangeurImage;
begin
end;

// PUBLIC //
procedure TDCocktail.SetVerreImageForSpeedButton(verre : TCocktailVerre ;  sb : TSpeedButton);
begin
  sb.Glyph := nil;
  VerreImageList.GetBitmap(integer(verre), sb.Glyph);
end;
procedure TDCocktail.SetVerreImageForBitBtn(verre : TCocktailVerre ; bb : TBitBtn);
begin
  bb.Glyph := nil;
  VerreImageList.GetBitmap(integer(verre), bb.Glyph);
end;
procedure TDCocktail.SetVerreImageForImage(verre : TCocktailVerre ; im : TImage);
begin
  im.Picture.Bitmap := nil;
  VerreImageList.GetBitmap(integer(verre), im.Picture.Bitmap);
  im.Transparent := true;
  im.Center := true;
end;

procedure TDCocktail.SetMelangeurImageForSpeedButton(verre : TCocktailMelangeur ;  sb : TSpeedButton);
begin
  sb.Glyph := nil;
  MelangeurImageList.GetBitmap(integer(verre), sb.Glyph);
end;
procedure TDCocktail.SetMelangeurImageForBitBtn(verre : TCocktailMelangeur ; bb : TBitBtn);
begin
  bb.Glyph := nil;
  MelangeurImageList.GetBitmap(integer(verre), bb.Glyph);
end;
procedure TDCocktail.SetMelangeurImageForImage(verre : TCocktailMelangeur ; im : TImage);
begin
  im.Picture.Bitmap := nil;
  MelangeurImageList.GetBitmap(integer(verre), im.Picture.Bitmap);
  im.Transparent := true;
  im.Center := true;
end;


end.
