unit F_About;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs;

type
  TFAboutBox = class(TForm)
    Panel1: TPanel;
    ProgramIcon: TImage;
    OKButton: TButton;
    Label1: TLabel;
    lVersion: TLabel;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Timer1: TTimer;
    Image1: TImage;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    lCopyright: TLabel;
    bMailTo: TBitBtn;
    lNbREcette: TLabel;
    lNbByte: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ProgramIconClick(Sender: TObject);
    procedure Label3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DoHypertextLink(leLabel : TLabel);
    procedure ShowListInfo;
  end;

var
  FAboutBox: TFAboutBox;

implementation

{$R *.DFM}
uses
  F_Main,
  U_CocktailConst,
  U_FuncString,
  ShellApi;
procedure TFAboutBox.ShowListInfo;
var
  m : integer;
  c : integer;
begin
  m := FMain.ListCocktail.MemoryUsed;
  c := FMain.ListCocktail.Count;
  lNbRecette.Caption := Format(SEARCH_NBRESULT,
  	[c,Pluriel(c)]);
  lNbByte.Caption := Format(INFO_DATA_MEMORY, [m, Pluriel(m)]);
end;

procedure TFAboutBox.FormCreate(Sender: TObject);
begin
  lVersion.Caption := APP_VERSION;
  lCopyright.Caption := INFO_COPYRIGHT;
  bMailTo.Hint := INFO_MAILTO;
  ShowListInfo;
end;

procedure TFAboutBox.Timer1Timer(Sender: TObject);
const
  TopMin = 80;
  TopMax = 16;
begin
  Shape1.Top := Shape1.Top - 1;
  if (Shape1.Top <= TopMax) then
    Shape1.Top := TopMin ;

  Shape2.Top := Shape2.Top - 1;
  if (Shape2.Top <= TopMax) then
    Shape2.Top := TopMin ;

  Shape3.Top := Shape3.Top - 1;
  if (Shape3.Top <= TopMax) then
    Shape3.Top := TopMin ;
end;

procedure TFAboutBox.ProgramIconClick(Sender: TObject);
begin
  ShowMessage(INFO_COPYRIGHT);
end;

procedure TFAboutBox.Label3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TLabel(Sender).Font.Color := clRed;
end;

procedure TFAboutBox.Label3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  TLabel(Sender).Font.Color := clBlue;
end;

procedure TFAboutBox.Label3Click(Sender: TObject);
begin
  DoHyperTextLink(TLabel(Sender));
end;

procedure TFAboutBox.DoHypertextLink(leLabel : TLabel);
var
  adr : string;
begin
  Screen.Cursor := crHourGlass;
  adr := LeLabel.Hint;
  if (adr = '') then
    adr := LeLabel.Caption;
  ShellExecute(0,
               nil,
               PCHAR(adr),
               nil,
               nil,
               SW_SHOWNORMAL);
  Screen.Cursor := crDefault;
end;

end.

