unit F_CocktailSearch;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, inifiles, Menus;

type
  TFCocktailSearch = class(TForm)
    gbCriteres: TGroupBox;
    eLiteral: TEdit;
    PanelCritere: TPanel;
    cbNom: TCheckBox;
    eNom: TEdit;
    mIngredients: TMemo;
    cbAlcoolList: TComboBox;
    cbTemperatureList: TComboBox;
    bSearch: TBitBtn;
    GroupBox1: TGroupBox;
    lbResult: TListBox;
    rbSortNom: TRadioButton;
    rbSortCritere: TRadioButton;
    lNbResult: TLabel;
    lbPredefIngred: TComboBox;
    pmIngredients: TPopupMenu;
    pmSuppr: TMenuItem;
    pmEffacerTout: TMenuItem;
    cbCondIngred: TComboBox;
    cbCondAlcool: TComboBox;
    cbCondTemp: TComboBox;
    cbCondLit: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure cbNomClick(Sender: TObject);
    procedure eNomChange(Sender: TObject);
    procedure bSearchClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure lbResultClick(Sender: TObject);
    procedure rbSortCritereClick(Sender: TObject);
    procedure _lbPredefIngredDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure _lbPredefIngredKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbPredefIngredClick(Sender: TObject);
    procedure eNomKeyPress(Sender: TObject; var Key: Char);
    procedure pmEffacerToutClick(Sender: TObject);
    procedure pmSupprClick(Sender: TObject);
    procedure cbCondIngredChange(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    ListOfResult : TList;
    procedure InitSearch;
    procedure InitComboList;
    procedure DoneSearch;
    procedure AddIngredientInPopMenu;
    procedure RefreshCriteres;
    procedure CreateRequette;
    procedure SearchRecette;
    procedure ShowResult;
    procedure WritePredefIngredients;
    procedure ReadPredefIngredients;
  end;


var
  FCocktailSearch: TFCocktailSearch;

const
  DEFAULT_USABLE_COLOR = clWhite;
  COND_NO = 0;
  COND_AND = 1;
  COND_OR = 2;
  ITEM_OP_AND = 1;
  ITEM_OP_OR  = 2;
var
  DEFAULT_UNUSABLE_COLOR : TColor;

implementation

{$R *.DFM}
uses
  F_Main,
  U_Cocktail, U_CocktailConst, {specif unit}
  C_Cocktail, {specif classes}
  U_FuncString, U_FuncFile, { func unit }
  U_FuncDebug,
  D_Cocktail;

type
  TItemListOfResult = packed record
    cockIdx      : integer;
    nbMatchField : integer;
    cock         : pTCocktailRecette;
  end;
  pTItemListOfResult = ^TItemListOfResult;

procedure TFCocktailSearch.FormCreate(Sender: TObject);
begin
  DEFAULT_UNUSABLE_COLOR := gbCriteres.Color;
  InitSearch;
  InitComboList;
  ListOfResult := TList.Create;
  lNbResult.Caption := '';
  // Chargement des CB de conditions (v1.6)
  // on se base sur le contenu de cbCondIngred
  cbCondAlcool.Items := cbCondIngred.Items;
  cbCondTemp.Items := cbCondIngred.Items;
  cbCondLit.Items := cbCondIngred.Items;
  cbCondIngred.ItemIndex := 0;
  cbCondAlcool.ItemIndex := 0;
  cbCondTemp.ItemIndex := 0;
  cbCondLit.ItemIndex := 0;
  RefreshCriteres;
end;

procedure TFCocktailSearch.FormShow(Sender: TObject);
begin
  FCocktailSearch.Left := 0;
  FCocktailSearch.Top := FMain.Top;
  FMain.Left := FCocktailSearch.Width;
  ReadPredefIngredients;
end;

procedure TFCocktailSearch.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DoneSearch;
  WritePredefIngredients;
  FMain.EnableToolBar(true);
end;

procedure TFCocktailSearch.FormDestroy(Sender: TObject);
begin
  DoneSearch;
  ListOfResult.Free;
  ListOfResult := nil;
end;

procedure TFCocktailSearch.DoneSearch;
var
  i : integer;
begin
  for i := 0 to ListOfResult.Count - 1 do
  begin
    Dispose(pTItemListOfResult(ListOfResult[i]));
  end;
  ListOfResult.Clear;
end;

procedure TFCocktailSearch.InitSearch;
begin
   cbNom.Checked := true;
//   cbEtOuIngredients.Enabled := false;
//   cbEtOuAlcool.Enabled := false;
//   cbAlcool.Checked := false;
//   cbEtOuTemperature.Enabled := false;
//   cbTemperature.Checked := false;
//   cbLiteral.checked := false;

//   cbEtOuIngredients.ItemIndex := 0;
//   cbEtOuAlcool.ItemIndex := 0;
//   cbEtOuTemperature.ItemIndex := 0;
   RefreshCriteres;
   lbResult.Clear;
end;

procedure TFCocktailSearch.InitComboList;
begin
  cbAlcoolList.Items := FMain.cbAlcool.Items;
  cbTemperatureList.Items := FMain.cbTemperature.Items;
end;

procedure TFCocktailSearch.RefreshCriteres;
  procedure SetComboStateColor(compo : TComboBox ; state : boolean);
  begin
    if (state = true) then
      compo.Color := DEFAULT_USABLE_COLOR
    else
      compo.Color := DEFAULT_UNUSABLE_COLOR;
    compo.enabled := state;
  end;
var
  condselected : integer;
begin

  if (cbnom.Checked = false) then
  begin
    eNom.Enabled := false;
    eNom.color := gbCriteres.Color;
  end
  else
  begin
    eNom.Enabled := true;
    eNom.Color := DEFAULT_USABLE_COLOR;
  end;

//  SetComboStateColor(cbEtOuIngredients, cbIngredient.Checked);
  {
  mIngredients.Enabled := cbIngredient.Checked;
  if (cbIngredient.Checked = false) then
    mIngredients.Color := gbCriteres.Color
  else
    mIngredients.Color := DEFAULT_USABLE_COLOR;
  }
  // Critere Ingrdients
  condselected := cbCondIngred.ItemIndex;
  mIngredients.enabled := not(condselected = 0);
  if (mIngredients.enabled) then
  begin
    mIngredients.Color := DEFAULT_USABLE_COLOR;
  end
  else
  begin
    mIngredients.Color := gbCriteres.Color;
  end;
  lbPredefIngred.enabled := mIngredients.enabled;
  lbPredefIngred.Color := mIngredients.Color;

  // Critre Alcool
  condselected := cbCondAlcool.ItemIndex;
  cbAlcoolList.Enabled := not(condselected = 0);
  if (cbAlcoolList.Enabled) then
    cbAlcoolList.Color := DEFAULT_USABLE_COLOR
  else
    cbAlcoolList.Color := gbCriteres.Color;

  // Critere temprature
  condselected := cbCondTemp.ItemIndex;
  cbTemperatureList.Enabled := not(condselected = 0);
  if (cbTemperatureList.Enabled) then
    cbTemperatureList.Color := DEFAULT_USABLE_COLOR
  else
    cbTemperatureList.Color := gbCriteres.Color;

  // Critere Litteral
  condselected := cbCondLit.ItemIndex;
  eLiteral.Enabled := not(condselected = 0);
  if (eLiteral.Enabled) then
    eLiteral.Color := DEFAULT_USABLE_COLOR
  else
    eLiteral.Color := gbCriteres.Color;

  CreateRequette;
end;

procedure TFCocktailSearch.cbNomClick(Sender: TObject);
begin
  RefreshCriteres;
  CreateRequette;
//  lbPredefIngred.Visible := cbIngredient.Checked;
end;

procedure TFCocktailSearch.CreateRequette;
// Construction de la requete de maniere textuele
function critreStr(cond : Integer ; critName : String ; critValue : String) : String;
var
  s : String;
begin
  if (cond = COND_AND) then s := 'ET '
  else if (cond = COND_OR) then s := 'OU ';
  if (cond <> COND_NO) then s := s + critName+' = "'+critValue+'" ';
  result := s;
end;

var
  s : string;
begin
  if (cbNom.checked) then s := 'Nom="'+eNom.Text+'" ';
  s := s + critreStr(cbCondIngred.ItemIndex, 'Ingredients', mIngredients.Text);
  s := s + critreStr(cbCondAlcool.ItemIndex, 'Alcool', cbAlcoolList.Text);
  s := s + critreStr(cbCondTemp.ItemIndex, 'Temperature', cbTemperatureList.Text);
  s := s + critreStr(cbCondLit.ItemIndex, 'Literal', eLiteral.Text);
  OutputDebug('Criteres:'+s);
(*
  if (cbLiteral.Checked = true) then
    s := 'Toutes recettes contenants "'+eLiteral.Text+'"'
  else
  begin
    if (cbNom.Checked = true) then
      s := 'Nom="'+eNom.Text+'"'
    else
      s := '';
{
    if (cbIngredient.Checked = true) then
      s := s + ' ET Ingredients="'+mIngredients.Text+'"';
}
    if (cbAlcool.Checked = true) then
      s := s + ' ET Alcool="'+cbAlcoolList.Text+'"';

    if (cbTemperature.Checked = true) then
      s := s + ' ET Temperature="'+cbTemperatureList.Text+'"';
  end;
  *)
end;

procedure TFCocktailSearch.eNomChange(Sender: TObject);
begin
  CreateRequette;
end;

procedure TFCocktailSearch.bSearchClick(Sender: TObject);
begin
  DoneSearch; // efface les anciens resultats
  lbResult.Clear;
  lNbResult.Caption := SEARCH_IN_SEARCH;
  Refresh;
  Screen.Cursor := crHourGlass;
  SearchRecette;
  Screen.Cursor := crDefault;

  if (ListOfResult.Count > 0) then
  begin // Ajout dans le menu contextuel des ingredients des ingredients choisi
    AddIngredientInPopMenu;
  end;

end;

procedure TFCocktailSearch.AddIngredientInPopMenu;
var
  i : integer;
  s : string;
begin
//  lbPredefIngred.Clear;
  for i := 0 to mIngredients.Lines.Count - 1 do
  begin
    s := AnsiUpperCase(mIngredients.Lines[i]);
    if (lbPredefIngred.Items.IndexOf(s) = -1) and (s <> '') then
      lbPredefIngred.Items.Add(s);
  end;
end;

procedure TFCocktailSearch.SearchRecette;

function SearchRecetteByLiteral(const pCock : pTCocktailRecette; str : string) : integer;
// retourne le nombre de champs qui match
var
  nbMatch : integer;
begin
  nbMatch := 0;
  if (str <> '') then
  begin
    inc (nbMatch, GetNumberOfStrInStr(str, pCock^.Nom));
    inc (nbMatch, GetNumberOfStrInStr(str, pCock^.Auteur));
    inc (nbMatch, GetNumberOfStrInStr(str, pCock^.Ingredients));
    inc (nbMatch, GetNumberOfStrInStr(str, pCock^.Photo));
    inc (nbMatch, GetNumberOfStrInStr(str, pCock^.Recette));
    inc (nbMatch, GetNumberOfStrInStr(str, pCock^.Video));
    inc (nbMatch, GetNumberOfStrInStr(str, CocktailMelangeur2Str(pCock^.Melangeur)));
    inc (nbMatch, GetNumberOfStrInStr(str, CocktailVerre2Str(pCock^.Verre)));
    inc (nbMatch, GetNumberOfStrInStr(str, CocktailCout2Str(pCock^.Cout)));
    inc (nbMatch, GetNumberOfStrInStr(str, CocktailGout2Str(pCock^.Gout)));
    inc (nbMatch, GetNumberOfStrInStr(str, CocktailAlcool2Str(pCock^.Alcool)));
    inc (nbMatch, GetNumberOfStrInStr(str, CocktailTemperature2str(pCock^.Temperature)));
  end;
  result := nbMatch;
end;

procedure AddRecetteInSearchResult(const pCock : pTCocktailRecette; idx : integer ; nbMatchField : integer);
var
  i : pTItemListOfResult;
begin
  new(i);
  i^.cockIdx := idx;
  i^.nbMatchField := nbMatchField;
  i^.cock := pcock;
  ListOfResult.Add(i);
end;
///////////////////// SearchRecette
var
  i : integer;
  pCock : pTCocktailRecette;
  nbMatchField : integer;
  match : boolean;
  tmp : integer;
  nb_ingred_choisi : integer;
begin
try
{  if (cbLiteral.Checked = true) then
  begin // recherche dans tout les champs
    for i := 0 to FMain.ListCocktail.Count - 1 do
    begin
      pCock := FMain.ListCocktail.ItemsPointer[i];
      nbMatchField := SearchRecetteByLiteral(pcock, eLiteral.Text);
      if (nbMatchField > 0) then
      begin
        AddRecetteInSearchResult(pcock, i, nbMatchField);
      end;
      if (i mod 100) = 0 then
      begin
        lNbResult.Caption := InfoPourcentage(i, FMain.ListCocktail.Count);
        Application.ProcessMessages;
      end;
    end;
  end
  else
  }

  begin // Recherche dans les champs selectionns
    // On parcours toute les recettes
    if (eNom.Text = '') then cbNom.Checked := false;
    mIngredients.Text := trim(mIngredients.Text);
    nb_ingred_choisi := mIngredients.Lines.Count;
    for i := 0 to FMain.ListCocktail.Count - 1 do
    begin
      nbMatchField := 0;
      match := true;
      pCock := FMain.ListCocktail.ItemsPointer[i];
      // Cherchons si cette recette match les criteres
      if (cbNom.Checked = true) then
      begin
      	tmp := GetNumberOfStrInStr(eNom.Text, pCock^.Nom);
      	match := ( tmp <> 0);
        if (match) then inc(nbMatchField, tmp);
			end;

			if (cbCondIngred.ItemIndex = COND_AND) then
      begin
        tmp := GetNumberOfMultiString(mIngredients.Lines, pCock^.Ingredients);
        if (match) and (tmp >= nb_ingred_choisi) then
        begin
					match := true;
          inc(nbMatchField, tmp);
        end
      	else
        	match := false;

      end
      else if (cbCondIngred.ItemIndex = COND_OR) then
      begin
        tmp := GetNumberOfMultiString(mIngredients.Lines, pCock^.Ingredients);
        if (tmp > 0) then
        begin
        	match := true;
	        inc(nbMatchField, tmp);
				end;
      end;

      if (cbCondAlcool.ItemIndex = COND_AND) then
      begin
        if (match) and (cbAlcoolList.ItemIndex = integer(pCock^.Alcool)) then
        begin
        	match := true;
          inc (nbMatchField);
        end
        else
        	match := false;
      end
      else if (cbCondAlcool.ItemIndex = COND_OR) then
      begin
        if (cbAlcoolList.ItemIndex = integer(pCock^.Alcool)) then
        begin
          match := true;
          inc (nbMatchField);
        end;
      end;

			if (cbCondTemp.ItemIndex = COND_AND) then
      begin
				if (match) and (cbTemperatureList.ItemIndex = integer(pCock^.Temperature)) then
        begin
      	  match := true;
          inc (nbMatchField);
        end
        else
        	match := false;
      end
      else if (cbCondTemp.ItemIndex = COND_OR) then
      begin
      	if (cbTemperatureList.ItemIndex = integer(pCock^.Temperature)) then
        begin
        	match := true;
          inc (nbMatchField);
        end;
      end;

      if (cbCondLit.ItemIndex = COND_AND) then
      begin
        if (match) and (SearchRecetteByLiteral(pcock, eLiteral.Text) > 0) then
        begin
      	  match := true;
          inc (nbMatchField);
        end
        else
        	match := false;
			end
      else if (cbCondLit.ItemIndex = COND_OR) then
      begin
        if (SearchRecetteByLiteral(pcock, eLiteral.Text) > 0) then
        begin
					match := true;
          inc (nbMatchField);
        end;
      end;
      if (nbMatchField > 0) then
      begin
        AddRecetteInSearchResult(pcock, i, nbMatchField);
      end;
      if (i mod 100) = 0 then
      begin
        lNbResult.Caption := InfoPourcentage(i, FMain.ListCocktail.Count);
        Application.ProcessMessages;
      end;
    end;
  end;
  lNbResult.Caption := Format(SEARCH_NBRESULT,[ListOfResult.Count, pluriel(ListOfResult.Count), pluriel(ListOfResult.Count)]);
  ShowResult;
except
end;
end;

function CompareByName(Item1, Item2: Pointer): Integer;
begin
  result := AnsiCompareText(pTCocktailRecette(pTItemListOfResult(Item1)^.Cock)^.Nom,
                            pTCocktailRecette(pTItemListOfResult(Item2)^.Cock)^.Nom);
end;

function CompareByCritere(Item1, Item2: Pointer): Integer;
begin
  if ( pTItemListOfResult(Item1)^.nbMatchField = pTItemListOfResult(Item2)^.nbMatchField) then
    result := CompareByName(Item1, Item2)
  else
    if (pTItemListOfResult(Item1)^.nbMatchField < pTItemListOfResult(Item2)^.nbMatchField) then
      result := +1
    else
      result := -1;
end;

procedure TFCocktailSearch.ShowResult;
var
  i : integer;
begin
  if (rbSortNom.checked = true) then
    ListOfResult.Sort(CompareByName)
  else
  if (rbSortCritere.Checked = true ) then
    ListOfResult.Sort(CompareByCritere);
  lbResult.Clear;
  for i := 0 to ListOfResult.Count - 1 do
  begin
    if (rbSortCritere.Checked = true) then
      lbResult.Items.Add(
      Format('%s (%d)',
      [pTCocktailRecette(pTItemListOfResult(ListOfResult[i])^.Cock)^.Nom, // Yeah, this is POINTER RULEZ !!
       pTItemListOfResult(ListOfResult[i])^.nbMatchField
      ]))
    else
      lbResult.Items.Add(pTCocktailRecette(pTItemListOfResult(ListOfResult[i])^.Cock)^.Nom );// Yeah, this is POINTER RULEZ !!);
  end;
end;

procedure TFCocktailSearch.lbResultClick(Sender: TObject);
var
  idx : integer;
  pRecetteChoisi : pTItemListOfResult;
begin
  idx := lbResult.ItemIndex;
  if (idx <> -1) and (idx < ListOfResult.Count) then
  begin
    pRecetteChoisi := ListOfResult[idx];
    FMain.sbCocktail.Position := pRecetteChoisi^.cockIdx;
  end;
end;

procedure TFCocktailSearch.rbSortCritereClick(Sender: TObject);
begin
  ShowResult;
end;

procedure TFCocktailSearch._lbPredefIngredDblClick(Sender: TObject);
var
  idx : integer;
begin
  idx := lbPredefIngred.ItemIndex;
  if (idx <> -1) then
  begin
    mIngredients.Lines.Add(lbPredefIngred.Items[idx]);
  end;
end;


procedure TFCocktailSearch.WritePredefIngredients;
var
  ini : TIniFile;
  i : integer;
  s : string;
begin { 1.5 (26/06/2001) : modif pour avoir toutes les valeurs dans une seule cle}
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  s := '';
  for i := 0 to lbPredefIngred.Items.Count - 1 do
  begin
    s := s + lbPredefIngred.Items[i] + ',';
  end;
  if (s <> '') then
  begin
    if (s[length(s)] = ',') then
      s := copy(s,1, length(s)-1);
  end;
  ini.WriteString(INI_SECTION_PREDEF, INI_PREDEF_INGREDS, s);
  Ini.Free;
end;

procedure TFCocktailSearch.ReadPredefIngredients;
var
  ini : TIniFile;
  ings,ing : string;
  p : integer;
begin  { 1.5 (26/06/2001) : modif pour avoir toutes les valeurs dans une seule cle}
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  ings := ini.ReadString(INI_SECTION_PREDEF, INI_PREDEF_INGREDS, '');
  // ing contient une chaine de la forme "ing1,ing2,ing3"
  repeat
    p := pos(',',ings);
    if (p = 0) then
    begin
      if (ings <> '') then
        ing := ings
      else
        ing := '';
    end
    else
      ing := copy(ings, 1, p-1);
    if (ing <> '') and (lbPredefIngred.Items.IndexOf(ing) = -1) then
      lbPredefIngred.Items.Add(ing);
    ings := copy(ings, p+1, length(ings));
  until (ings='') or (p=0);

  ini.Free;
end;

procedure TFCocktailSearch._lbPredefIngredKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
var
  idx : integer;
begin
  If (key = 46) then // Suppr
  begin
    idx := lbPredefIngred.ItemIndex;
    if (idx <> -1) then
    begin
      lbPredefIngred.Items.Delete(idx);
    end;
  end
  else
    Key := 0;
end;

procedure TFCocktailSearch.lbPredefIngredClick(Sender: TObject);
var
  idx : integer;
begin
  idx := lbPredefIngred.ItemIndex;
  if (idx <> -1) then
  begin
    mIngredients.Lines.Add(lbPredefIngred.Items[idx]);
  end;
end;

procedure TFCocktailSearch.eNomKeyPress(Sender: TObject; var Key: Char);
begin
  if(key = #13) then
  begin
    key := #0;
    bSearchClick(nil);
  end;
end;

procedure TFCocktailSearch.pmEffacerToutClick(Sender: TObject);
begin
  mIngredients.Lines.Clear;
end;

// __JF v 1.52 (01/03/2003) supression d'un ingrdient de la liste
procedure TFCocktailSearch.pmSupprClick(Sender: TObject);
var
  line : Integer;
  i : integer;
  l : integer;
  lenline : integer;
begin
  line := mIngredients.SelStart;   // Premier caractere selectionn, ou position du curseur
  // Chercher la ligne correspondant  cette position
  l := 0;
  for i := 0 to mIngredients.Lines.Count-1 do
  begin
    lenline := length(mIngredients.Lines[i]);
    if (line >= l) and (line <= (l + lenline )) then
    begin
      mIngredients.Lines.Delete(i);
      break;
    end
    else
      l := l + lenline + 2; // +2 car il y'a un CRLF  la fin de chaque ligne
  end;

end;

procedure TFCocktailSearch.cbCondIngredChange(Sender: TObject);
begin
  RefreshCriteres;
  CreateRequette;
end;



end.
