unit F_DialogColor;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls;

type
  TFDialogColor = class(TForm)
    Bevel1: TBevel;
    ColorEnCours: TPanel;
    PanelImage: TPanel;
    Palette: TImage;
    PanelRVB: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lR: TLabel;
    lV: TLabel;
    lB: TLabel;
    cbDegrad: TCheckBox;
    DegradColor: TPanel;
    PanelBlack: TPanel;
    PanelFuschia: TPanel;
    PanelRed: TPanel;
    PanelYellow: TPanel;
    PanelAqua: TPanel;
    PanelLime: TPanel;
    PabelBlue: TPanel;
    Panelwhite: TPanel;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Verre: TImage;
    VerreOriginal: TImage;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    eRVB: TEdit;
    procedure PaletteMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaletteClick(Sender: TObject);
    procedure PaletteMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaletteMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure cbDegradClick(Sender: TObject);
    procedure PanelBlackClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
    FColor : integer;
    FColorDegrad : integer;
    FX,FY : integer;
    MouseClicked : boolean;
    procedure DrawVerre(verre : TImage);
  public
    { Public declarations }
    CouleurChoisi : integer;
    function  Execute : boolean;
    procedure DrawVerreNoDegrad(col : TColor ; verre : TImage);
    procedure DrawVerreDegrad(col1, col2 : TColor ; verre : TImage);
//    property  CouleurChoisi : integer read FColor write FColor;
    Property  CouleurDegrad : integer read FColorDegrad write FColorDegrad;
  end;

var
  FDialogColor: TFDialogColor;

implementation

function  TFDialogColor.Execute : boolean;
begin
  MouseClicked := false;
//
  DrawVerreNoDegrad(CouleurChoisi, Verre);
  ColorEnCours.Color := CouleurChoisi;
  FColor := CouleurChoisi;
  if (ShowModal = mrOk) then
    result := true
  else
    result := false;
end;

{$R *.DFM}

function RVB2Color(r,v,b : integer) : integer;
begin
  result := ( byte(b mod 256) shl 16) +
            ( byte(v mod 256) shl 8) +
            ( byte(r mod 256));
end;

procedure ColorToRVB(color : TColor ; var r,v,b : byte);
begin
  r := color and $000000FF;
  v := color and $0000FF00 shr 8;
  b := color and $00FF0000 shr 16;
end;

procedure TFDialogColor.PaletteMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  r,v,b : byte;
begin
  ColorEnCours.Color := Palette.Canvas.Pixels[x,y];
  FX := x;
  FY := y;
  ColorToRVB(ColorEnCours.Color, r,v,b);
  lR.Caption := IntToStr(r);
  lV.Caption := IntToStr(v);
  lB.Caption := IntToStr(b);
  if (MouseClicked = true) then
    PaletteClick(self);
end;

procedure TFDialogColor.PaletteClick(Sender: TObject);
begin
  if (cbDegrad.Checked = true) then
  begin
    CouleurDegrad := FColor;
    FColor := Palette.Canvas.Pixels[Fx,Fy];
    DegradColor.Color := CouleurDegrad;
    DrawVerreDegrad(FColor, CouleurDegrad, Verre);
  end
  else
  begin
    FColor := Palette.Canvas.Pixels[Fx,Fy];
    ColorEnCours.Color := FColor;
    DrawVerreNoDegrad(FColor, Verre);
  end;
end;

procedure TFDialogColor.DrawVerre(verre : TImage);
begin

{  // Rempli la zone de la meme couleur que le fond de la fenetre
  Verre.Canvas.Pen.Color := FDialogColor.Color;
  Verre.Canvas.Pen.Style := psSolid;
  Verre.Canvas.Pen.Mode := pmCopy;
  Verre.Canvas.Brush.Color := FDialogColor.Color;
  Verre.Canvas.Rectangle(0,0,Verre.Width, Verre.Height);

  // Trait du bas
  Verre.Canvas.Pen.Color := clBlack;
  Verre.Canvas.MoveTo(0, Verre.Height-1);
  Verre.Canvas.LineTo(Verre.Width, Verre.Height-1);

  //  Trait vertical
  Verre.Canvas.MoveTo(Verre.Width div 2, Verre.Height-1);
  Verre.Canvas.LineTo(Verre.Width div 2, Verre.Height div 2);

  // Trait diagonal gauche
  Verre.Canvas.LineTo(0,0);

  // Trait diagonal droit
  Verre.Canvas.MoveTo(Verre.Width div 2, Verre.Height div 2);
  Verre.Canvas.LineTo(Verre.Width, 0);

  // Trait horizontal
  Verre.Canvas.LineTo(0,0);}
  Verre.Picture := VerreOriginal.Picture;
end;

procedure TFDialogColor.DrawVerreNoDegrad(col : TColor; verre : TImage);
var
  r,v,b : byte;
begin
  DrawVerre(verre);
  Verre.Canvas.Brush.Color := Col;
  Verre.Canvas.FloodFill((Verre.Width div 2), (Verre.Height div 2 )- 4,
                         Verre.Canvas.Pixels[(Verre.Width div 2), (Verre.Height div 2 )- 4], fsSurface);

  ColorToRVB(Col, r,v,b);
  eRVB.Text :=  Format('%d,%d,%d (%0.2X%0.2X%0.2X)', [r,v,b,r,v,b]);
end;

procedure TFDialogColor.DrawVerreDegrad(col1, col2 : TColor ; verre : TImage);
var
  r,v,b : single;
  r2,v2,b2 : byte;
  dr,dv,db : single;
  di : single;
  x,y : integer;
  x2 : integer;
  i : single;
begin
  DrawVerre(verre);
  i := 0;
  di := (Verre.Width / verre.Height );
  ColorToRVB(col1, r2,v2,b2);
  r := r2; v := v2; b := b2;
  ColorToRVB(col2, r2,v2,b2);
  if (r2 <> 0) then
    dr := r / r2
  else
    dr := 0;
  if (v2 <> 0) then
    dv := v / v2
  else
    dv := 0;
  if (b2 <> 0) then
    db := b / b2
  else
    db := 0;
  for y := (Verre.Height div 2)-1 downto  0  do
  begin
    Verre.Canvas.Pen.Color := RVB2Color(trunc(r),trunc(v),trunc(b));

    x := (Verre.Width div 2) - trunc(i) ;
    x2 := (Verre.Width div 2) + trunc(i);
    i := i + di;
    r := r + dr;
    v := v + dv;
    b := b + db;
    Verre.Canvas.MoveTo(x,y);
    Verre.Canvas.LineTo(x2,y);
  end;
end;


procedure TFDialogColor.PaletteMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MouseClicked := true;
end;

procedure TFDialogColor.PaletteMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  MouseClicked := false;
end;

procedure TFDialogColor.FormCreate(Sender: TObject);
begin
  FX := 0; FY := 0;
end;

procedure TFDialogColor.cbDegradClick(Sender: TObject);
begin
  DegradColor.Visible := cbDegrad.Checked;
end;

procedure TFDialogColor.PanelBlackClick(Sender: TObject);
begin
  FColor := TPanel(Sender).Color;
  ColorEnCours.Color := FColor;
  DrawVerreNoDegrad(FColor, verre);
end;

procedure TFDialogColor.BitBtn1Click(Sender: TObject);
begin
  CouleurChoisi := FColor;
end;

procedure TFDialogColor.BitBtn3Click(Sender: TObject);
begin
  FColor := -1;
  CouleurChoisi := -1;
  Close;
end;

end.
