unit F_Proportion;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, F_Main,
  StdCtrls, ExtCtrls;

type
  TFProportion = class(TForm)
    Shape1: TShape;
    lError: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    ShapeList : TList;
    LabelList : TList;
    Procedure ShowProportion(ingred : string);
  end;

var
  FProportion: TFProportion;

implementation

{$R *.DFM}
const
  NiceColorTab : array[0..7] of integer = (clBlue,
                                           clFuchsia,
                                           clGreen,
                                           clLime,
                                           clNavy,
                                           clOlive,
                                           clTeal,
                                           clYellow  );

function MyStrToFloatDef(str : string ; def : single) : single;
var
  seppos : integer;
  entier : integer;
  frac : single;
  sentier : string;
  sfrac : string;
begin
  sentier := '';
  sfrac := '';
  seppos := pos(',', str);
  if (seppos = 0) then seppos := pos('.', str);
  if (seppos = 0) then seppos := pos(';', str);
  if (seppos = 0) then
    sEntier := Copy(str, 1, length(str))
  else
  begin
    sEntier := Copy(str, 1, seppos - 1);
    sFrac := copy(str, seppos+1, length(str));
  end;
  if (sEntier = '') then
    result := def
  else
  begin
    entier := StrToIntDef(sEntier, -1); // v1.51
    if (entier = -1) then
    begin
      FProportion.lError.visible := true;
      result := 0;
    end
    else
    begin
        frac := StrToFloat('0'+DecimalSeparator+sfrac);
        result := Entier + frac;
    end;
  end;
end;

function AffValue(val : single): string;
begin
  if (frac(val) <> 0) then
    result := Format('%.2f', [val])
  else
    result := IntToStr(trunc(val));
end;

Procedure TFProportion.ShowProportion(ingred : string);
var
  list : TStringList;
  Shape : TShape;
  i : integer;
  som : single;
  val : single;
  sval : string;
  p : integer;
  height : integer;
begin
  som := 0;
  list := TStringList.Create;
  List.Text := ingred;
  for i := 0 to list.Count - 1 do
  begin
    p := pos(' ', list[i]);
    if (p = 0) then p := pos('c', list[i]);
    if (p <> 0) then
    begin
      sval := Copy(list[i], 1, p -1);
//      val := StrToIntDef(sval, -1);
//      val := StrToFloat(sval);
      val := MyStrToFloatDef(sval, -1);
      if (val <> -1) then
      begin
        som := som + val;
        Shape := TShape.Create(self);
        Shape.Tag := trunc(val*100); // pour eviter que 0.5 = 0 , 0.5= 50
//        Shape.Width := trunc(frac(val) * 10);
        Shape.Brush.Color := NiceColorTab[i mod 7];
        ShapeList.Add(Shape);
        LabelList.Add(TLabel.Create(Self));
      end;
    end;
  end;

  if (som <> 0) then
  begin
    for i := ShapeList.Count - 1 downto 0 do
    begin
      height := trunc(170 * ( ((TShape(ShapeList[i]).Tag)/100) / som));
      TShape(ShapeList[i]).Width := 97;
      TShape(ShapeList[i]).Height := height;
      TShape(ShapeList[i]).Left := Shape1.Left;
      if (i = ShapeList.Count - 1) then
        TShape(ShapeList[i]).Top := 12
      else
        TShape(ShapeList[i]).Top := TShape(ShapeList[i+1]).Height + TShape(ShapeList[i+1]).Top;
      TLabel(LabelList[i]).Caption := Format('%s/%s', [ AffValue(TShape(ShapeList[i]).Tag/100), AffValue(som)]);
      TLabel(LabelList[i]).Left := 2;
      TLabel(LabelList[i]).Top := TShape(ShapeList[i]).Top;
      TLabel(LabelList[i]).Parent := Self;
      TLabel(LabelList[i]).Show;
      TShape(ShapeList[i]).Parent := self;
      TShape(ShapeList[i]).Show;
    end;
  end;
  List.Free;
end;


procedure TFProportion.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i := 0 to ShapeList.Count - 1 do
    TShape(ShapeList[i]).Free;
  for i := 0 to LabelList.Count - 1 do
    TShape(LabelList[i]).Free;
  ShapeList.Free;
  LabelList.Free;
end;

procedure TFProportion.FormCreate(Sender: TObject);
begin
  ShapeList := TList.Create;
  LabelList := TList.Create;
  lError.visible := false;
end;

procedure TFProportion.FormClick(Sender: TObject);
begin // 1.52
     ShowMessage('La fentre de proportions vous aide  valuer les quantites '#10#13
     +'de chaque ingrdients de la recette.');
end;

end.
