unit F_Splash;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, iniFiles;

type
  TFSplash = class(TForm)
    Panel: TPanel;
    Info: TLabel;
    ProgressBar2: TProgressBar;
    Animate: TAnimate;
    lPleaseWait: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
    AviMaxFrame : integer;
  public
    { Dclarations publiques }
    procedure SetProgress(prog : integer);
    procedure SetProgressMax(max : integer);

  end;

var
  FSplash: TFSplash;

implementation

{$R *.DFM}
uses
  u_FuncFile,
  u_CocktailConst;
procedure TFSplash.SetProgress(prog : integer);
// prog : 0..100
const
  T : DWORD = -1;
  TEMPOIMG = 250;
var
  frame : integer;
begin
  ProgressBar2.Position := prog;
  if (AviMaxFrame <> -1) then
  begin
    // Si un avi est demand au chargement, on affiche l'image toute les TEMPOIMG ms
    if (T = -1) then
    begin
      frame := 1 + trunc((prog/100) * AviMaxFrame);
      T := GetTickCount;
      Animate.Seek(frame);
    end
    else
    begin
      if (GetTickCount - T > TEMPOIMG) then
      begin
        frame := 1 + trunc((prog/100) * AviMaxFrame);
        T := GetTickCount;
        Animate.Seek(frame);
      end;
    end;
  end;

end;

procedure TFSplash.SetProgressMax(max : integer);
begin
  ProgressBar2.Max := max;
  Application.ProcessMessages;
end;


procedure TFSplash.FormCreate(Sender: TObject);
var
  ini : TIniFile;
  avifilename : string;
label
  NoAvi;
begin
  ini := TIniFile.Create(GetIniFileName(INI_FILENAME));
  avifilename := ini.ReadString(INI_SECTION_GENERAL, INI_SPLASH_AVI, '');
  if (aviFileName <> '') then
  begin
    if (FileExists(AviFileName) = false) then
      AviFileName := PathToExe + AviFileName;
    try
      animate.FileName := aviFileName;
    except
      animate.FileName := '';
    end;
    if (animate.FileName = '') then
      goto NoAvi;
    ProgressBar2.Visible := false;
    lPleaseWait.Top := 8;
    Animate.Top := 32;
    AviMaxFrame := Animate.StopFrame;
  end
  else
  begin
NoAvi:
    animate.Visible := false;
    ProgressBar2.Visible := true;
    AviMaxFrame := -1;
  end;
  ini.Free;//
end;

end.
