unit U_FuncDebug;
{** U_FuncDebug.pas
 ** __JF 22/03/2001
 ** Unit for manipulating debugging functions
 **}

interface

procedure OutputDebug(const str : string);
procedure OutputDebugFormat(const str: string; const Args: array of const);

var { 1.5 (26/06/2001) }
  PROG_IS_IN_DEBUG : boolean;
implementation

uses
  SysUtils, windows;

procedure OutputDebug(const str : string);
begin
  if (PROG_IS_IN_DEBUG) then { 1.5 (26/06/2001) }
    Writeln(TimeToStr(now)+':'+str);
end;

procedure OutputDebugFormat(const str: string; const Args: array of const);
begin
  if (PROG_IS_IN_DEBUG) then { 1.5 (26/06/2001) }
    Writeln(TimeToStr(now)+':'+Format(str, args));
end;

procedure InitDebug;
var
  i : integer;
begin
  PROG_IS_IN_DEBUG := false;
  for i := 1 to paramcount do
  begin
    if uppercase(paramstr(i)) = '-DEBUG' then
    begin
      PROG_IS_IN_DEBUG := true;
      AllocConsole;
      Outputdebug(paramstr(0)+' started ' + DateTimeTostr(now));
    end;
  end;
end;

initialization
  InitDebug; { 1.5 (26/06/2001) }
end.
