unit U_FuncReg;
{** u_FuncReg.pas
 ** __JF 22/03/2001
 ** Unit for manipulating registry functions
 **}

interface

uses
  Windows;

function  EcritRegistre(racine:DWord;clef,nom,valeur:string) : integer;
procedure Associe(extension: string;executable:string;icone:string);
function  RetireAssociation(extension: string) : integer;

implementation

uses
  Registry;

function  EcritRegistre(racine:DWord;clef,nom,valeur:string) : integer;
{procdure servant  crire dans la base de registre. Racine est le noeud principal de la base de registre (ex: HKEY_CLASSES_ROOT )}
{clef est le noeuds choisi o l'on veut crire (un noeud correspond  un noeud dans l'arborescence de la base de registre)}
{nom est le nom auquel on veut affecter une valeur}
{valeur est la valeur en question}
Var Registre:TRegistry;
begin
  Registre:=TRegistry.Create;  // Cration de Registre
  try                             // try except end sont facultatifs. Voir mon exemple traitant de ce sujet (les exeptions).
    Registre.RootKey:=Racine; //spcifie la cl racine choisi pour l'application
    Registre.OpenKey(clef,True);  //Permet de slectionner une clef particulire.
                                         // Une clef est un noeud de l'arborescence de la base de registre.
                                         // True car on veut que si le noeud n'existe pas on le cre.
    Registre.WriteString(nom,valeur); //affecte dans la base de registre la valeur valeur au nom nom
    Registre.CloseKey; //Ecrit la cl en cours dans le registre et ferme cette cl.
    Registre.Free;               // libration de la mmoire (annule l'effet de create)
    result := 0;
  except
//    Showmessage('erreur d''criture dans la base de registre');
    Registre.Free;  // libre la mmoire mme en cas d'erreur.
    result := -1;
  end;
end;

procedure Associe(extension: string;executable:string;icone:string);
//procdure permettant d'associer une extension extension  un executable executable
begin
   EcritRegistre(HKEY_CLASSES_ROOT,'.'+extension,'',extension+'_file');
   EcritRegistre(HKEY_CLASSES_ROOT, extension+'_file\shell\open\command','',executable+' "%1"');
   if (icone <> '') then
     EcritRegistre(HKEY_CLASSES_ROOT, extension+'_file\DefaultIcon','',icone)
   else
     EcritRegistre(HKEY_CLASSES_ROOT, extension+'_file\DefaultIcon','',executable)
end;

function retireassociation(extension: string) : integer;
Var Registre:TRegistry;
begin
    Registre:=TRegistry.Create;  // Cration de Registre
  try                             // try except end sont facultatifs. Voir mon exemple traitant de ce sujet (les exeptions).
    Registre.RootKey:=HKEY_CLASSES_ROOT; //spcifie la clef racine choisi pour l'application
    Registre.DeleteKey('.'+extension);  //efface le noeud
    Registre.Free;
    Registre:=TRegistry.Create;
    Registre.RootKey:=HKEY_CLASSES_ROOT;
    Registre.DeleteKey(extension+'_file\shell\open\command'); //efface le noeud
    Registre.DeleteKey(extension+'_file\shell\open');
    Registre.DeleteKey(extension+'_file\shell');
    Registre.DeleteKey(extension+'_file');
    Registre.CloseKey; //Ecrit la cl en cours dans le registre et ferme cette cl.
    Registre.Free;               // libration de la mmoire (annule l'effet de create)
    result := 0;
  except
//    Showmessage('erreur');
    Registre.Free;  // libre la mmoire mme en cas d'erreur.
    result := -1;
  end;
end;

end.
