unit u_func;

interface

uses
  sysutils,
  windows,
  classes,
  graphics;

procedure OutputDebug(const str : string);
procedure OutputDebugFormat(const str: string; const Args: array of const);
function GetIniFileName(inifilename : string) : string;
function ExtractOnlyFileName(filename : string) : string; // in 'c:\toto.txt' out 'toto.txt';
function GetFilenameExtension(filename : string) : string; // in 'prout.bmp' out 'BMP'
//function ConvertToRelativePath(const filename : string) : string ; // in 'c:\temp\toto.txt' ou '..\toto.txt'
function IsStrInStr(const substr, str : string) : boolean;
function GetNumberOfStrInStr(substr, str : string) : integer; // Retourne le nombre de souschaine dans une chaine
function GetNumberOfMultiString(substrs : TStrings ; const str : string) : integer;
function BooleanToStrYN(b : boolean) : string; // Return 'Oui' or 'Non'
function RemoveAccent(const str : string) : string;
procedure RemoveAccentEx(var str : string);
function  CleanStrings(str : string) : string;
procedure associe(extension: string;executable:string;icone:string);
function retireassociation(extension: string) : integer;
function RemoveCRLFfromStr(const str : string ) : string;
function BrowseForComputer(const winhandle : THANDLE; const title : string) : string; //affiche une boite de dialogue pour slectionner un ordinateur  public
function BrowseForPath(const Handle : THandle; const Title : String) : string;
function FileNameToValidFileName(const filename : string) : string;
function InfoPourcentage(val , max : integer) : string;
function Pluriel(n : integer) : string; // retourne 's' si n > 1
function GetFileSizeAsString(const filename : string) : string;
function GetFileSizeInKB(const FileName : string) : integer;
Function GetFileModifierDate(const FileName : string) : string;
procedure AppendSlashToPath(var path : string);
function ExtractFileNameWithoutExt(FileNames:string):string;
function SimplifyPath(var path : string) : integer; // c:\temp\prout\..\ -> c:\temp\
function  GetShellInfo(filename : string ; var hI : HICON ) : string;
var
  PathToExe : string; // Chemin o se trouve 'cocktail.exe'
Const
  NiceColorTab : array[0..7] of integer = (clBlue,
                                           clFuchsia,
                                           clGreen,
                                           clLime,
                                           clNavy,
                                           clOlive,
                                           clTeal,
                                           clYellow  );
implementation
uses
  Registry,
  shlobj,
  ShellAPI;
function GetIniFileName(inifilename : string) : string;
begin
  Result := PathToExe+IniFileName;
end;

function ExtractOnlyFileName(filename : string) : string; // in 'c:\toto.txt' out 'toto.txt';
begin
  result := ExtractFileName(filename);
end;

function GetFilenameExtension(filename : string) : string; // in 'prout.bmp' out 'BMP'
var
  ext : string;
begin
  ext := ExtractFileExt(filename);
  if (ext <> '') then
    ext := AnsiUpperCase(copy(ext, 2, length(ext)));
  result := ext;
end;

function IsStrInStr(const substr, str : string) : boolean;
begin
  result := pos(AnsiUpperCase(substr), AnsiUpperCase(str)) > 0;
end;

function GetNumberOfStrInStr(substr, str : string) : integer; // Retourne le nombre de souschaine dans une chaine
var
  r : integer;
  i,j : integer;
  find : boolean;
begin
// TO DO : should return the number of substring 'substr' in string 'str'
  if (substr = '') then
  begin
    result := 0;
    exit;
  end;
  substr := AnsiUpperCase(substr);
  RemoveAccentEx(SubStr);
  str := AnsiUpperCase(str);
  RemoveAccentEx(Str);
 { else
    if (IsStrInStr(substr, str) = true) then
      result := 1
    else
      result := 0;
 }
  r := 0;
  i := 1;
  while (i<length(str)) do
  begin
    if (str[i] = substr[1]) then
    begin
      find := true;
      for j := 2 to length(substr) do
      begin
        if (substr[j] <> str[i+j-1]) then
        begin
          find := false;
          break;
        end;
      end;
      if (find = true) then
      begin
        inc(r);
        i := i + length(substr)-1;
      end;
    end;
    inc(i);
  end;
  result := r;

end;

function GetNumberOfMultiString(substrs : TStrings; const str : string) : integer;
var
  i : integer;
  nbMatch : integer;
  tmpstr : TStringList;
  j : integer;
  s1,s2 : string;
begin
{  nbMatch := 0;
  for i := 0 to SubStrs.Count - 1 do
  begin
    inc(nbMatch, GetNumberOfStrInStr(SubStrs[i], str));
  end;
  result := nbMatch;}
  nbMatch := 0;
  tmpstr := TStringList.Create;
  TmpStr.Text := AnsiUpperCase(str);
  for i := 0 to SubStrs.Count - 1 do
  begin
    s1 := AnsiUpperCase(SubStrs[i]);
    RemoveAccentEx(s1);
    for j := 0 to TmpStr.Count - 1 do
    begin
      s2 := TmpStr[j];
      RemoveAccentEx(s2);
      if (pos(s1, s2) <> 0) then
      begin
        inc(nbMatch);
        break;
      end;
    end;
  end;
  TmpStr.Free;
  result := nbMatch;
end;

function BooleanToStrYN(b : boolean) : string; // Return 'Oui' or 'Non'
begin
  if (b) then
    result := 'Oui'
  else
    result := 'Non';
end;

const
    Accents = '';
  NoAccents = 'AAAAAACEEEEIIIIDNOOOOOOUUUUYBaaaaaaceeeeiiiionoooooouuuuyby';
function RemoveAccent(const str : string) : string;
var
  i : integer;
  p : integer;
  s : string;
begin
  s := '';
  for i := 1 to length(str) do
  begin
    p := pos(str[i], Accents);
    if (p <> 0) then
      s := s + NoAccents[p]
    else
      s := s + str[i];
  end;
  result := s;
end;

procedure RemoveAccentEx(var str : string);
var
  i : integer;
  p : integer;
begin
  for i := 1 to length(str) do
  begin
    p := pos(str[i], Accents);
    if (p <> 0) then
      str[i] := NoAccents[p];
  end;
end;

function  CleanStrings(str : string) : string;
var
  j : integer;
  templist : TStringList;
begin
    templist := TstringList.Create;
      templist.Text := str;
      for j := 0 to templist.Count - 1 do
      begin
        templist[j] := Trim(templist[j]);
      end;
      j := 0;
      while (j <= templist.Count - 1) do
      begin
        if (templist[j] = '') then
          templist.Delete(j);
        inc(j);
      end;
      result := templist.Text;
    templist.Free;
end;

function  EcritRegistre(racine:DWord;clef,nom,valeur:string) : integer;
{procdure servant  crire dans la base de registre. Racine est le noeud principal de la base de registre (ex: HKEY_CLASSES_ROOT )}
{clef est le noeuds choisi o l'on veut crire (un noeud correspond  un noeud dans l'arborescence de la base de registre)}
{nom est le nom auquel on veut affecter une valeur}
{valeur est la valeur en question}
Var Registre:TRegistry;
begin
  Registre:=TRegistry.Create;  // Cration de Registre
  try                             // try except end sont facultatifs. Voir mon exemple traitant de ce sujet (les exeptions).
    Registre.RootKey:=Racine; //spcifie la cl racine choisi pour l'application
    Registre.OpenKey(clef,True);  //Permet de slectionner une clef particulire.
                                         // Une clef est un noeud de l'arborescence de la base de registre.
                                         // True car on veut que si le noeud n'existe pas on le cre.
    Registre.WriteString(nom,valeur); //affecte dans la base de registre la valeur valeur au nom nom
    Registre.CloseKey; //Ecrit la cl en cours dans le registre et ferme cette cl.
    Registre.Free;               // libration de la mmoire (annule l'effet de create)
    result := 0;
  except
//    Showmessage('erreur d''criture dans la base de registre');
    Registre.Free;  // libre la mmoire mme en cas d'erreur.
    result := -1;
  end;
end;

procedure associe(extension: string;executable:string;icone:string);
//procdure permettant d'associer une extension extension  un executable executable
begin
   EcritRegistre(HKEY_CLASSES_ROOT,'.'+extension,'',extension+'_file');
   EcritRegistre(HKEY_CLASSES_ROOT, extension+'_file\shell\open\command','',executable+' "%1"');
   if (icone <> '') then
     EcritRegistre(HKEY_CLASSES_ROOT, extension+'_file\DefaultIcon','',icone)
   else
     EcritRegistre(HKEY_CLASSES_ROOT, extension+'_file\DefaultIcon','',executable)
end;

function retireassociation(extension: string) : integer;
Var Registre:TRegistry;
begin
    Registre:=TRegistry.Create;  // Cration de Registre
  try                             // try except end sont facultatifs. Voir mon exemple traitant de ce sujet (les exeptions).
    Registre.RootKey:=HKEY_CLASSES_ROOT; //spcifie la clef racine choisi pour l'application
    Registre.DeleteKey('.'+extension);  //efface le noeud
    Registre.Free;
    Registre:=TRegistry.Create;
    Registre.RootKey:=HKEY_CLASSES_ROOT;
    Registre.DeleteKey(extension+'_file\shell\open\command'); //efface le noeud
    Registre.DeleteKey(extension+'_file\shell\open');
    Registre.DeleteKey(extension+'_file\shell');
    Registre.DeleteKey(extension+'_file');
    Registre.CloseKey; //Ecrit la cl en cours dans le registre et ferme cette cl.
    Registre.Free;               // libration de la mmoire (annule l'effet de create)
    result := 0;
  except
//    Showmessage('erreur');
    Registre.Free;  // libre la mmoire mme en cas d'erreur.
    result := -1;
  end;
end;

procedure OutputDebug(const str : string);
{$IFDEF DEBUG}
{$ENDIF}
begin
{$IFDEF DEBUG}
  Writeln(TimeToStr(now)+':'+str);
{$ENDIF}
end;

procedure OutputDebugFormat(const str: string; const Args: array of const);
begin
{$IFDEF DEBUG}
  Writeln(TimeToStr(now)+':'+Format(str, args));
{$ENDIF}
end;

function RemoveCRLFfromStr(const str : string ) : string;
var
  s : string;
  i : integer;
begin
  s := '';
  for i := 1 to length(str) do
  begin
    if (str[i] = #$0A) then
      s := s + ';'
    else
    if (str[i] <> #$0D) then
      s := s + str[i];
{
  ToDo : remplacer les CRLF par des CR, mais le pb c'est que
         excel ne reformate pas correctement les lignes avec des CR
    c := str[i];
    if (c = #$0D) then
      break;
    if (c = #$0A) and (i > 2) and (str[i-1] = #$0D) then
    begin // une suite $0D $0A
      c := ';';
    end;
    s := s + c;}
  end;
  result := s;
end;

function BrowseForComputer(const winhandle : THANDLE; const title : string) : string; //affiche une boite de dialogue pour slectionner un ordinateur  public
var
  BrowseInfo: TBrowseInfo;
  IDRoot: PItemIDList;
  Path: array[0..MAX_PATH] of Char;
begin
  // Get the Item ID for Network Neighborhood
  SHGetSpecialFolderLocation(winHandle, CSIDL_NETWORK, IDRoot);
  ZeroMemory(@BrowseInfo, SizeOf(TBrowseInfo));
  ZeroMemory(@path, MAX_PATH);
  BrowseInfo.hwndOwner := winhandle;
  BrowseInfo.pidlRoot := IDRoot;
  BrowseInfo.lpszTitle := PChar(title);
  BrowseInfo.pszDisplayName := @path;
  // Include this flag to show computer only
  BrowseInfo.ulFlags := BIF_BROWSEFORCOMPUTER;// or BIF_RETURNONLYFSDIRS   ;
  // Show the browse dialog, get the Item ID for the selected item and convert it to a path
  SHBrowseForFolder(BrowseInfo);
//  SHGetPathFromIDList(IDList, Path);
  result := path;
end;

function BrowseForPath(const Handle : THandle; const Title : String) : string;
var
  BrowseInfo : TBrowseInfo;
  RetBuffer,
  ResultBuffer : Array[0..255] of char;
  PIDL : PItemIDList;
begin

  //Initialize buffers
  FillChar(BrowseInfo,SizeOf(TBrowseInfo),#0);
  Fillchar(RetBuffer,SizeOf(RetBuffer),#0);
  FillChar(ResultBuffer,SizeOf(ResultBuffer),#0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.pszDisplayName := @Retbuffer;
  BrowseInfo.lpszTitle := @Title[1];

  // we want a status-text
  BrowseInfo.ulFlags := BIF_StatusText;

  // Our call-back function cheching for fileexist
  BrowseInfo.lpfn := nil; //@BrowseCallBack;

  // Show BrowseForDlg
  PIDL := SHBrowseForFolder(BrowseInfo);

  // Return fullpath to file
  if SHGetPathFromIDList(PIDL,ResultBuffer) then
    result := StrPas(ResultBuffer)
  else
    Result := '';
  GlobalFreePtr(PIDL);  //Clean up
end;

function FileNameToValidFileName(const filename : string) : string;
const
  INVALIDCHAR = '/\:*?"<>|';
var
  i : integer;
  s : string;
begin
  s := '';
  for i := 1 to length(FileName) do
  begin
    if (pos(FileName[i], INVALIDCHAR) <> 0) then
    begin
      s := s + '_';
    end
    else
      s := s + FileName[i];
  end;
  result := s;
end;

function InfoPourcentage(val , max : integer) : string;
begin
  if (max = 0) then result := '?%'
  else
    result := IntToStr(trunc((val / max)*100))+'%';
end;

{function ConvertToRelativePath(const filename : string) : string ;
// Converti un chemin absolu en chemin relatif par rapport a PathToExe
var
  fn : string;
  exepath : string;
  DriveExe : string;
  Drivefn : string;
begin
  fn := upperCase( ExtractFileName(filename));
  exepath := UpperCase(ExtractFilePath(PathToExe));
  DriveExe := ExtractFileDrive(exepath);
  DriveFn  := ExtractFileDrive(fn);
  try
    if (DriveExe[1] <> DriveExe[2]) then
    begin
      // Les chemins sont sur des disq <> : on peut pas relativiser
      result := filename;
      exit;
    end;
  except
      result := filename;
      exit;
  end;

  // C'est un peu compliqu...
  result := filename;
end;
 }
function Pluriel(n : integer) : string; // retourne 's' si n > 1
begin
  if (n > 1) then result := 's' else result := '';
end;
//----------------------------------------------------------------------------//

function GetFileSizeAsString(const filename : string) : string;
var
  lo : DWORD;
  hi : DWORD;
  fd : THANDLE;
  l : TLargeInteger;
begin
  fd := CreateFile(PCHAR(filename),
                   GENERIC_READ,
                   FILE_SHARE_READ,
                   nil,
                   OPEN_EXISTING,
                   FILE_ATTRIBUTE_NORMAL,
                   0);
  if (fd = INVALID_HANDLE_VALUE) then
    result := '???'
  else
  begin
    lo := GetFileSize(fd, @hi);
    if (lo = -1) and (GetLastError <> NO_ERROR) then
    begin
      result := '???';
    end
    else
    begin
      l.LowPart := lo;
      l.HighPart := hi;
      if (l.QuadPart <= 1024) then
        result := IntToStr(l.LowPart)
      else if (l.QuadPart <= (1024 * 1024)) then
        result := IntToStr(l.LowPart div 1024)+'K'
      else if (l.QuadPart <= (1024 * 1024*1024)) then
        result := IntToStr(l.LowPart div (1024))+'K'
      else result := IntToStr(l.LowPart div (1024*1024))+'M';
    end;
    CloseHandle(fd);
  end;
end;


function GetFileSizeInKB(const FileName : string) : integer;
var
  lo : DWORD;
  hi : DWORD;
  fd : THANDLE;
  l : TLargeInteger;
begin
  fd := CreateFile(PCHAR(filename),
                   GENERIC_READ,
                   FILE_SHARE_READ,
                   nil,
                   OPEN_EXISTING,
                   FILE_ATTRIBUTE_NORMAL,
                   0);
  if (fd = INVALID_HANDLE_VALUE) then
    result := 0
  else
  begin
    lo := GetFileSize(fd, @hi);
    if (lo = -1) and (GetLastError <> NO_ERROR) then
    begin
      result := 0;
    end
    else
    begin
      l.LowPart := lo;
      l.HighPart := hi;
      result := Integer(l.LowPart div 1024);
    end;
    CloseHandle(fd);
  end;
end;

procedure AppendSlashToPath(var path : string);
var
  l : integer;
begin
  l := length(path);
  if (l > 0) then
  begin
    if path[l] <> '\' then
      path := path + '\';
  end;
end;

function ExtractFileNameWithoutExt(FileNames:string):string;
// in : toto.txt, out : toto
var
  S:string;
begin
  S:='';
  while Pos('.', FileNames) > 0 do
  begin
    S:=S+Copy(FileNames,1,Pos('.',FileNames)-1);
    Delete(FileNames,1,Pos('.',FileNames));
  end;
  result:=S;
end;

function SimplifyPath(var path : string) : integer; // c:\temp\prout\..\ -> c:\temp\
var
  lpFileName : pchar;
  lpBuffer : array[0..MAX_PATH] of char;
begin
  lpFileName := PCHAR(path);
  result := GetFullPathName(lpFileName, MAX_PATH, lpBuffer, lpFileName);
  path := lpBuffer;
end;

function  GetShellInfo(filename : string ; var hI : HICON ) : string;
var
  fi : TSHFileInfo;
begin
  if (SHGetFileInfo(PCHAR(filename),
                0,
                fi,
                SizeOf(TSHFileInfo),
                SHGFI_ICON or SHGFI_TYPENAME ) <> 0) then
  begin
    hi := fi.hIcon;
    result := fi.szTypeName;
  end
  else
  begin
    hi := 0;
    result := '';
  end;
end;

Function GetFileModifierDate(const FileName : string) : string;
var
  ft : TFileTime;
  dosdate : integer;
  fd : THANDLE;
begin
  fd := CreateFile(PCHAR(filename),
                   GENERIC_READ,
                   FILE_SHARE_READ,
                   nil,
                   OPEN_EXISTING,
                   FILE_ATTRIBUTE_NORMAL,
                   0);
  if (fd = INVALID_HANDLE_VALUE) then
    result := '???'
  else
  begin
    dosdate := FileGetDate(fd);
    if (dosdate <> -1) then
    begin
      result := DateTimeToStr(FileDateToDateTime(dosdate));
    end
    else
      result := '???';

  end; 
end;

begin
  PathToExe := ExtractFilePath(paramstr(0));
end.

