unit U_Cocktail;

interface
type
  TCocktailMelangeur = (melShaker,
                        melVerreAMelange,
                        melElectrique,
                        melDirectVerre,
                        melCuisson,
                        melAutre);
  TCocktailVerre = (verreCocktail,
                    verreTumbler,
                    verreOldFashioned,
                    verreFlute,
                    verreCoupe,
                    verrePilsener,
                    verreBallon,
                    verreTulipe,
                    verreChaleur,
                    verreDegustation,
                    verreFizz,
                    verreAutre);
  TCocktailCout = (coutPeu,
                   coutRaisonnable,
                   coutCher);
  TCocktailGout    = (goutBeurk,
                      goutBof,
                      goutMouais,
                      goutMmm,
                      goutSlurp,
                      goutIndefini);
  TCocktailAlcool = (alcoolSans,
                     alcoolLeger,
                     alcoolDur,
                     alcoolTresDur,
                     alcoolAie);
  TCocktailTemperature = ( tempGelee,
                           tempFroid,
                           tempChambre,
                           tempChaud,
                           tempBrulant);

  TCocktailRecette = packed record
    Nom              : string[30];
    Id               : integer;
    Melangeur        : TCocktailMelangeur;
    Verre            : TCocktailVerre;
    Cout             : TCocktailCout;
    NbPersonne       : shortint;
    Gout             : TCocktailGout;
    Alcool           : TCocktailAlcool;
    Temperature      : TCocktailTemperature;
    Bulle            : Boolean;
    Couleur1         : integer;
    Couleur2         : integer;
    Auteur           : string[30];
  // !!! Les type String doivent obligatoirement se trouver
  // !!! a la fin de la structure
    Photo            : string;
    Video            : string;
    Ingredients      : string;
    Recette          : string;
  end;
  PTCocktailRecette = ^TCocktailRecette;

function CocktailMelangeur2Str(mel : TCocktailMelangeur) : string;
function CocktailVerre2Str(verre : TCocktailVerre) : string;
function CocktailCout2Str(cout : TCocktailCout) : string;
function CocktailGout2str(gout : TCocktailGout) : string;
function CocktailAlcool2Str(alcool : TCocktailAlcool) : string;
function CocktailTemperature2str(temp : TCocktailTemperature) : string;
procedure InitPCocktailRecette(cock : pTCocktailRecette);
procedure CopyRecette(Src : TCocktailRecette ; var Dst : TCocktailRecette);
implementation
uses
  sysutils;
function CocktailMelangeur2Str(mel : TCocktailMelangeur) : string;
begin
  case mel of
    melShaker        : result := 'Shaker';
    melVerreAMelange : result := 'Verre  mlange';
    melElectrique    : result := 'Mlangeur lectrique';
    melDirectVerre   : result := 'Directement dans le verre';
    melCuisson       : result := 'Ncessite une cuisson';
    melAutre         : result := 'Autre';
  else
    result := '???';
  end;
end;
function CocktailVerre2Str(verre : TCocktailVerre) : string;
begin
  case verre of
    verreCocktail     : result := 'Cocktail';
    verreTumbler      : result := 'Tumbler';
    verreOldFashioned : result := 'Old-fashioned';
    verreFlute        : result := 'Flte';
    verreCoupe        : result := 'Coupe';
    verrePilsener     : result := 'Pilsener';
    verreBallon       : result := 'Ballon';
    verreTulipe       : result := 'Tulipe';
    verreChaleur      : result := 'Resitant  la chaleur';
    verreDegustation  : result := 'Dgustation';
    verreFizz         : result := 'Fizz';
    verreAutre        : result := 'Autre';
  else
    result := '???';
  end;
end;

function CocktailCout2Str(cout : TCocktailCout) : string;
begin
  case cout of
    coutPeu         : result := 'Peu';
    coutRaisonnable : result := 'Raisonnable';
    coutCher        : result := 'Cher';
  else
    result := '???';
  end;
end;

function CocktailGout2str(gout : TCocktailGout) : string;
begin
  case gout of
    goutBeurk    : result := 'Beurk';
    goutBof      : result := 'Bof';
    goutMouais   : result := 'Mouais';
    goutMmm      : result := 'Mmmm';
    goutSlurp    : result := 'Slurp';
    goutIndefini : result := 'Indfini';
  else
    result := '???';
  end;
end;

function CocktailAlcool2Str(alcool : TCocktailAlcool) : string;
begin
  case alcool of
    alcoolSans    : result := 'Sans';
    alcoolLeger   : result := 'Leger';
    alcoolDur     : result := 'Dur';
    alcoolTresDur : result := 'Trs dur';
    alcoolAie     : result := 'Ae !';
  else
    result := '???';
  end;
end;

function CocktailTemperature2str(temp : TCocktailTemperature) : string;
begin
  case temp of
    tempGelee   : result := 'Gele';
    tempFroid   : result := 'Froide';
    tempChambre : result := 'Chambre';
    tempChaud   : result := 'Chaude';
    tempBrulant : result := 'Brlante';
  else
    result := '???';
  end;
end;

procedure InitPCocktailRecette(cock : pTCocktailRecette);
begin
  system.FillChar(cock^, SizeOf(TCocktailRecette), 0);
  cock^.Photo := '';
  cock^.Video := '';
  cock^.Ingredients := '';
  cock^.Recette := '';
  cock^.Couleur1 := -1;
  cock^.Couleur2 := -1;
end;

procedure CopyRecette(Src : TCocktailRecette ; var Dst : TCocktailRecette);
begin
  system.Move(src, dst, SizeOf(TCocktailRecette));
  Dst.Photo := String(src.Photo);
  Dst.Video := String(src.Video);
  Dst.Ingredients := String(src.Ingredients);
  Dst.Recette := String(src.Recette);
end;
end.
