unit U_ReplaceTexte;
{** Unit U_ReplaceTexte.pas
 **
 ** Unit grant une classe TReplaceMacro, qui
 ** permet de faire du remplacement de macro dans une stringlist.
 ** OriginalText : stringlist (cre par l'objet) qui contient
 **   le texte avec les macro
 ** MacroValue : stringlist qui contient les valeurs associs aux macro
 **   de la forme "nom_macro=valeur" (ex : "$USER=toto")
 ** ModifiedText : stringlist contenant le text de OriginalText apres le
 **   remplacement des macro par ReplaceMacro.
 **
 **}
interface

uses
  Windows, SysUtils, Classes;

type
  TReplaceMacro = class
  public
    OriginalText : TStringList;
    MacroValue   : TStringList; // de la forme "$macro=value"
    ModifiedText : TStringList;
    constructor Create;
    destructor  Destroy; override;
    procedure   ReplaceMacro;
  end;

implementation

constructor TReplaceMacro.Create;
begin
  OriginalText := TStringList.Create;
  MacroValue := TStringList.Create;
  ModifiedText := TStringList.Create;
  inherited;
end;

destructor TReplaceMacro.Destroy;
begin
  OriginalText.Free;
  MacroValue.Free;
  ModifiedText.Free;
  inherited;
end;

procedure TReplaceMacro.ReplaceMacro;
var
  p : integer;
  i : integer;
  mac, val : string;
  t : string;
  t2 : string;
begin
  t := OriginalText.Text;
  for i := 0 to MacroValue.Count - 1 do
  begin
    mac := MacroValue[i];
    val := '';
    p := pos('=', mac);
    if (p <> 0) then
    begin
      val := copy(mac, p+1, length(mac));
      mac := copy(mac, 1, p-1);
    end;
    repeat
      p := pos(mac, t);
      if (p <> 0) then
      begin
        t2 := t;
        t := copy(t2, 1, p-1);
        t := t + val;
        t := t + copy(t2, p+length(mac), length(t2));
      end
      else
      begin
      end;
    until( p = 0);
  end;
  ModifiedText.Text := t;
end;

end.
